## MPRIS Last.fm Cover Downloader
# Real-time Album Cover Management

MPRIS Last.fm Cover Downloader seamlessly integrates with your music playback to ensure your album covers are always up-to-date without manual intervention. By leveraging the MPRIS interface and Last.fm API, this tool automatically downloads missing album covers, eliminating the need for constant polling and reducing CPU usage.
Automatic Cover Downloads for Every Track

When a new track starts playing, the application checks for the presence of the album cover in your local music directory. If the cover is missing, it fetches the highest available resolution image from Last.fm and saves it automatically.

The downloader intelligently selects the largest available cover image from Last.fm, ensuring high-quality visuals for your music library. It prioritizes sizes in the following order: mega, extralarge, large, medium, small.
Efficient Resource Usage

Designed to minimize CPU usage, the application avoids unnecessary polling by reacting to real-time events from the MPRIS interface. This ensures your system remains responsive and efficient while managing album covers.

# Requirements

    Operating System: Linux
    Python Dependencies:
        requests
        dbus-next
        pathlib
        logging
    System Tools:
        mpdris2-rs
        MPD (Music Player Daemon) or another MPRIS-compatible player
    Last.fm Account to obtain an API key.

# Installation

git clone the repo.
just copy the files to the same location as they are in the repository

# Configuration

```bash
systemctl --user daemon-reload
systemctl --user enable mpdcovergrabber.service
systemctl --user start mpdcovergrabber.service
```
Put your lastfm apikey here $HOME/apikeys/lastfm

# Contributing

Contributions are welcome! To improve this application, please follow these steps:

    Fork the Repository.

    Create a New Branch for Your Feature or Fix:

git checkout -b feature/new-feature

Make Your Changes and Commit Them:

git commit -m "Add new feature"

Push Your Changes to the Fork:

    git push origin feature/new-feature

    Open a Merge Request on GitLab.

License

This project is licensed under the BSD License. See the LICENSE file for details.
Contact

If you have any questions or suggestions, feel free to open an issue in the repository or contact me directly via me@priet.us.

Thank you for using MPRIS Last.fm Cover Downloader! We hope this tool makes managing your music album covers easier and more efficient.

